org.apache.jasper.xmlparser

## Class UTF8Reader

- java.lang.Object
- - java.io.Reader
  - - org.apache.jasper.xmlparser.UTF8Reader

All Implemented Interfaces:
  Closeable, AutoCloseable, Readable

    public class UTF8Reader
    extends Reader

Author:
  Andy Clark, IBM

### Field Summary

Fields
`protected byte[]` `fBuffer` Byte buffer.
`protected InputStream` `fInputStream` Input stream.
`protected int` `fOffset` Offset into buffer.

### Fields inherited from class java.io.Reader

`lock`

### Constructor Summary

Constructors
Constructor and Description
`UTF8Reader(InputStream inputStream, int size)` Constructs a UTF-8 reader from the specified input stream, buffer size and MessageFormatter.

### Method Summary

Methods
`void` `close()` Close the stream.
`void` `mark(int readAheadLimit)` Mark the present position in the stream.
`boolean` `markSupported()` Tell whether this stream supports the mark() operation.
`int` `read()` Read a single character.
`int` `read(char[] ch, int offset, int length)` Read characters into a portion of an array.
`boolean` `ready()` Tell whether this stream is ready to be read.
`void` `reset()` Reset the stream.
`long` `skip(long n)` Skip characters.

### Methods inherited from class java.io.Reader

`read, read`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### fInputStream

    protected InputStream fInputStream

Input stream.

#### fBuffer

    protected byte[] fBuffer

Byte buffer.

#### fOffset

    protected int fOffset

Offset into buffer.

### Constructor Detail

#### UTF8Reader

    public UTF8Reader(InputStream inputStream,
              int size)

Constructs a UTF-8 reader from the specified input stream, buffer size and MessageFormatter.

Parameters:
  `inputStream` - The input stream.
  `size` - The initial buffer size.

### Method Detail

#### read

    public int read()
             throws IOException

Read a single character. This method will block until a character is available, an I/O error occurs, or the end of the stream is reached.

Subclasses that intend to support efficient single-character input should override this method.

Overrides:
  `read` in class `Reader`
Returns:
  The character read, as an integer in the range 0 to 16383 (`0x00-0xffff`), or -1 if the end of the stream has been reached
Throws:
  `IOException` - If an I/O error occurs

#### read

    public int read(char[] ch,
           int offset,
           int length)
             throws IOException

Read characters into a portion of an array. This method will block until some input is available, an I/O error occurs, or the end of the stream is reached.

Specified by:
  `read` in class `Reader`
Parameters:
  `ch` - Destination buffer
  `offset` - Offset at which to start storing characters
  `length` - Maximum number of characters to read
Returns:
  The number of characters read, or -1 if the end of the stream has been reached
Throws:
  `IOException` - If an I/O error occurs

#### skip

    public long skip(long n)
              throws IOException

Skip characters. This method will block until some characters are available, an I/O error occurs, or the end of the stream is reached.

Overrides:
  `skip` in class `Reader`
Parameters:
  `n` - The number of characters to skip
Returns:
  The number of characters actually skipped
Throws:
  `IOException` - If an I/O error occurs

#### ready

    public boolean ready()
                  throws IOException

Tell whether this stream is ready to be read.

Overrides:
  `ready` in class `Reader`
Returns:
  True if the next read() is guaranteed not to block for input, false otherwise. Note that returning false does not guarantee that the next read will block.
Throws:
  `IOException` - If an I/O error occurs

#### markSupported

    public boolean markSupported()

Tell whether this stream supports the mark() operation.

Overrides:
  `markSupported` in class `Reader`

#### mark

    public void mark(int readAheadLimit)
              throws IOException

Mark the present position in the stream. Subsequent calls to reset() will attempt to reposition the stream to this point. Not all character-input streams support the mark() operation.

Overrides:
  `mark` in class `Reader`
Parameters:
  `readAheadLimit` - Limit on the number of characters that may be read while still preserving the mark. After reading this many characters, attempting to reset the stream may fail.
Throws:
  `IOException` - If the stream does not support mark(), or if some other I/O error occurs

#### reset

    public void reset()
               throws IOException

Reset the stream. If the stream has been marked, then attempt to reposition it at the mark. If the stream has not been marked, then attempt to reset it in some way appropriate to the particular stream, for example by repositioning it to its starting point. Not all character-input streams support the reset() operation, and some support reset() without supporting mark().

Overrides:
  `reset` in class `Reader`
Throws:
  `IOException` - If the stream has not been marked, or if the mark has been invalidated, or if the stream does not support reset(), or if some other I/O error occurs

#### close

    public void close()
               throws IOException

Close the stream. Once a stream has been closed, further read(), ready(), mark(), or reset() invocations will throw an IOException. Closing a previously-closed stream, however, has no effect.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in class `Reader`
Throws:
  `IOException` - If an I/O error occurs